#ifndef WAVCAP_H
#define WAVCAP_H

#include <windows.h>
#include <mmsystem.h>
#include <string.h>
#include <stdio.h>

#pragma comment(lib, "winmm.lib")

/* ========================================================================= */
/* == MACRO DEFINE                                                           */
/* ========================================================================= */
#define RECORD_RING_MAX				90

/* ========================================================================= */
/* == STRUCT DEFINE                                                          */
/* ========================================================================= */
/*
 * 16 (bits) * 16000 (Hz) * 0.01 (sec) = 2560 (bits)
 *                                     = 320  (bytes)
 */
#define MAX_BUFF					320000		// 3200(100msec)

typedef int WCENDIAN;
#define WCENDIAN_LITTLE				0
#define WCENDIAN_BIG				1

typedef struct ST_RINGBUFF {
        long    timestamp;
        long    hour;
        long    min;
        long    sec;
        long    msec;
        long    lBufferSize;
        char    voice[MAX_BUFF];        /*  */
} TY_RINGBUFF;

class WavCap{
public:
	WavCap();
	~WavCap();
	bool CapStart(int buffsize, WCENDIAN endian);
	bool CapEnd();
	bool makeWaveHeader(char wavHeader[44], unsigned int datSize);

private:
	HWAVEIN m_hWaveIn;
	WAVEFORMATEX m_stWFEX;
	WAVEHDR m_stWhdr1, m_stWhdr2;
	char *m_stWbuff1, *m_stWbuff2;
};

#endif